/*
 * crc_ccitt.c
 *
 * Created: 28.07.2014 12:55:53
 *  Author: Administrator
 */ 

#include <stddef.h>
#include <util/crc16.h>		// from avr-libc 1.8.0

/********************************************************************************
*																				*
*																				*
********************************************************************************/
#define returnReversedVal(val)		typeof(val)	reversedVal = 0, \
												outMask = (typeof(val))1<<( (sizeof( val)<<3)-1);	/* set MSB; */ \
										do { \
											if( val & 0x01) { \
												reversedVal |= outMask; \
											} \
											val >>= 1; \
										} while( (outMask >>= 1)); \
										return( reversedVal);

/********************************************************************************
*																				*
*																				*
********************************************************************************/
uint16_t reverseBitOrder16 (uint16_t val)
{
	returnReversedVal(val);		// 
}
/*
uint8_t reverseBitOrder8 (uint8_t val)
{
	returnReversedVal(val);
}
uint32_t reverseBitOrder32 (uint32_t val)
{
	returnReversedVal(val);
}
uint64_t reverseBitOrder64 (uint64_t val)
{
	returnReversedVal(val);
}
*/

/********************************************************************************
*																				*
*																				*
********************************************************************************/
int main(void)
{
 uint16_t	crcNoAugment =		0xFFFF,	// the "regular" initial crc value for ccitt
			// initializations for a pre-augmented CCITT - the result is the same for all following examples:
//			crcPreAugment =		_crc_ccitt_update( _crc_ccitt_update( crcNoAugment, 0x00), 0x00),	// the most straight forward version;
//			crcPreAugment =		reverseBitOrder16( 0x1D0F),		// you have probably seen this 0x1D0F value before;
																// it's the pre-augmented crc ccitt value for implementations that
																// shift in the most significant bit first;
																// remember: the implementation in avr libc works with LSB first,
																// so we have to reverse the value (MSB <-> LSB) which results in 0xF0B8;
			crcPreAugment =		0xF0B8,							// 0x1D0F -> reversed bit order -> 0xF0B8;
			crcPostAugment;										// an attempt: will hold the crcNoAugment crc and will be extended by 16 zero bits;
																// did not work;
 uint8_t	dataPayLoad[] = { 0x01, 0x73 },	// the data payload, we want to apply the ccitt calculation on;
			*srcDataPtr,
			c;									// current character

	srcDataPtr = dataPayLoad;
	
	// calc the crcs
	for( size_t i = sizeof(dataPayLoad); i--; ) {

		c = *srcDataPtr++;

		crcPreAugment =	_crc_ccitt_update( crcPreAugment, c);	// update of PRE-AUGMENTED crc
		crcNoAugment =	_crc_ccitt_update( crcNoAugment, c);	// update of NON-AUGMENTED crc
	}

	// attempt to post-augment the non-augmented version (append 16 zero bits after calculating crc
	// based on data payload);
	crcPostAugment = _crc8_ccitt_update( _crc8_ccitt_update( crcNoAugment, 0x00), 0x00);
	
	// with the above rawDataPayLoad[] = { 0x01, 0x73 } we now have:
	// crcNoAugment		=	0xA87C		// could get matching results with breitbandkatze, but not with srec_cat;
										// as soon as I do not augment with srec_cat (-NO-AUGment option),
										// I can't manage to get a match at all (unless I manually augment
										// AFTER the calculating the crc over the datapayload w/ 16 zero bits,
										// but then it's not a non-augmented version anymore);
										// maybe there's some kind of issue related to the -NO-AUGment option,
										// but I can't tell yet due to a lack of comprehension of
										// the ccitt "voodoo magic";
										
	//*****************************************************************************************
	//*************************************************************************************** *
	// crcPreAugment	=	0x5BE5	// matches with online calculator from breitbandkatze	* * <-- that's the one!
									// (see settings in the three screen shot,  they all	* * <-- that's the one!
									// result in the same CCITT = 0x5BE5); it also matches  * * <-- that's the one!
									// the crc from srec_cat (see the corresponding script);* * <-- that's the one!
									// with the calculator from lamertbies it did not work, * * <-- that's the one!
									// because there's no option to change the bit order    * * <-- that's the one!
									// (it uses MSB first);									* * <-- that's the one!
	//*************************************************************************************** *
	//*****************************************************************************************
	// crcPostAugment	=	0x005E		// could not get any match with this attempt;
										// I assume depending on the CCITT function in use, you
										// can either pre-augment OR post-augment;
										// the srec_cat (V1.64) implementation seems to use / need
										// (if augmenting manually) post-augmentation;
	return( 0);
}
